<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.18"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>XHXKit: XHXKit/Classes/Base/Foundation/XHXThreadSafeDictionary.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &#160;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.18 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_x_h_x_thread_safe_dictionary_8m_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">XHXThreadSafeDictionary.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_x_h_x_thread_safe_dictionary_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">//  XHXThreadSafeDictionary.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">//  KKLOnlineHD</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//  Created by Leovir on 2018/2/26.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//  Copyright © 2018年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_x_h_x_thread_safe_dictionary_8h.html">XHXThreadSafeDictionary.h</a>&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define INIT(...) self = super.init; \</span></div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">   11</a></span>&#160;<span class="preprocessor">if (!self) return nil; \</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">__VA_ARGS__; \</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">if (!_dic) return nil; \</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">_lock = dispatch_semaphore_create(1); \</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">return self;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#define LOCK(...) dispatch_semaphore_wait(_lock, DISPATCH_TIME_FOREVER); \</span></div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">   19</a></span>&#160;<span class="preprocessor">__VA_ARGS__; \</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">dispatch_semaphore_signal(_lock);</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="category_x_h_x_thread_safe_dictionary_07_08.html">   22</a></span>&#160;<span class="keyword">@interface </span><a class="code" href="interface_x_h_x_thread_safe_dictionary.html">XHXThreadSafeDictionary</a> ()</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;{</div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="category_x_h_x_thread_safe_dictionary_07_08.html#ab51cad326f8cc54a6d19790ff716ae8b">   24</a></span>&#160;    NSMutableDictionary *<a class="code" href="category_x_h_x_thread_safe_dictionary_07_08.html#ab51cad326f8cc54a6d19790ff716ae8b">_dic</a>;</div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="category_n_s_mutable_dictionary_07_x_h_x_safe_08.html#a857aae19cd120d8dd38e94e0db4c1b53">   25</a></span>&#160;    dispatch_semaphore_t _lock;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;}</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">@end</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">@implementation </span><a class="code" href="interface_x_h_x_thread_safe_dictionary.html">XHXThreadSafeDictionary</a></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#pragma mark - init</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;- (instancetype)init {</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">INIT</a>(_dic = [[NSMutableDictionary alloc] init]);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;}</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;- (instancetype)initWithObjects:(NSArray *)objects forKeys:(NSArray *)keys {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">INIT</a>(_dic =  [[NSMutableDictionary alloc] initWithObjects:objects forKeys:keys]);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;}</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;- (instancetype)initWithCapacity:(NSUInteger)capacity {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">INIT</a>(_dic = [[NSMutableDictionary alloc] initWithCapacity:capacity]);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;}</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;- (instancetype)initWithObjects:(const <span class="keywordtype">id</span>[])objects forKeys:(const <span class="keywordtype">id</span> &lt;NSCopying&gt;[])keys count:(NSUInteger)cnt {</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">INIT</a>(_dic = [[NSMutableDictionary alloc] initWithObjects:objects forKeys:keys count:cnt]);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;- (instancetype)initWithDictionary:(NSDictionary *)otherDictionary {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">INIT</a>(_dic = [[NSMutableDictionary alloc] initWithDictionary:otherDictionary]);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;}</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;- (instancetype)initWithDictionary:(NSDictionary *)otherDictionary copyItems:(BOOL)flag {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">INIT</a>(_dic = [[NSMutableDictionary alloc] initWithDictionary:otherDictionary copyItems:flag]);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;}</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#pragma mark - method</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;- (NSUInteger)count {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSUInteger c = _dic.count); <span class="keywordflow">return</span> c;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;- (id)objectForKey:(<span class="keywordtype">id</span>)aKey {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(<span class="keywordtype">id</span> o = [_dic objectForKey:aKey]); <span class="keywordflow">return</span> o;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;}</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;- (NSEnumerator *)keyEnumerator {</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSEnumerator * e = [_dic keyEnumerator]); <span class="keywordflow">return</span> e;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;}</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;- (NSArray *)allKeys {</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSArray * a = [_dic allKeys]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;}</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;- (NSArray *)allKeysForObject:(<span class="keywordtype">id</span>)anObject {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSArray * a = [_dic allKeysForObject:anObject]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;}</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;- (NSArray *)allValues {</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSArray * a = [_dic allValues]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;}</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;- (NSString *)description {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSString * d = [_dic description]); <span class="keywordflow">return</span> d;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;}</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;- (NSString *)descriptionInStringsFileFormat {</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSString * d = [_dic descriptionInStringsFileFormat]); <span class="keywordflow">return</span> d;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;}</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;- (NSString *)descriptionWithLocale:(<span class="keywordtype">id</span>)locale {</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSString * d = [_dic descriptionWithLocale:locale]); <span class="keywordflow">return</span> d;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;}</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;- (NSString *)descriptionWithLocale:(<span class="keywordtype">id</span>)locale indent:(NSUInteger)level {</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSString * d = [_dic descriptionWithLocale:locale indent:level]); <span class="keywordflow">return</span> d;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;}</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;- (BOOL)isEqualToDictionary:(NSDictionary *)otherDictionary {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordflow">if</span> (otherDictionary == <span class="keyword">self</span>) <span class="keywordflow">return</span> YES;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">if</span> ([otherDictionary isKindOfClass:<a class="code" href="interface_x_h_x_thread_safe_dictionary.html">XHXThreadSafeDictionary</a>.class]) {</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <a class="code" href="interface_x_h_x_thread_safe_dictionary.html">XHXThreadSafeDictionary</a> *other = (id)otherDictionary;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        BOOL isEqual;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        dispatch_semaphore_wait(_lock, DISPATCH_TIME_FOREVER);</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        dispatch_semaphore_wait(other-&gt;_lock, DISPATCH_TIME_FOREVER);</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        isEqual = [_dic isEqual:other-&gt;_dic];</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        dispatch_semaphore_signal(other-&gt;_lock);</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        dispatch_semaphore_signal(_lock);</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordflow">return</span> isEqual;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    }</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;}</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;- (NSEnumerator *)objectEnumerator {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSEnumerator * e = [_dic objectEnumerator]); <span class="keywordflow">return</span> e;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;}</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;- (NSArray *)objectsForKeys:(NSArray *)keys notFoundMarker:(<span class="keywordtype">id</span>)marker {</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSArray * a = [_dic objectsForKeys:keys notFoundMarker:marker]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;}</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;- (NSArray *)keysSortedByValueUsingSelector:(<span class="keywordtype">SEL</span>)comparator {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSArray * a = [_dic keysSortedByValueUsingSelector:comparator]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;}</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;- (void)getObjects:(<span class="keywordtype">id</span> __unsafe_unretained[])objects andKeys:(<span class="keywordtype">id</span> __unsafe_unretained[])keys {</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic getObjects:objects andKeys:keys]);</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;}</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;- (id)objectForKeyedSubscript:(<span class="keywordtype">id</span>)key {</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(<span class="keywordtype">id</span> o = [_dic objectForKeyedSubscript:key]); <span class="keywordflow">return</span> o;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;}</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;- (void)enumerateKeysAndObjectsUsingBlock:(<span class="keywordtype">void</span> (^)(<span class="keywordtype">id</span> key, <span class="keywordtype">id</span> obj, BOOL *stop))block {</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic enumerateKeysAndObjectsUsingBlock:block]);</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;}</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;- (void)enumerateKeysAndObjectsWithOptions:(NSEnumerationOptions)opts usingBlock:(<span class="keywordtype">void</span> (^)(<span class="keywordtype">id</span> key, <span class="keywordtype">id</span> obj, BOOL *stop))block {</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic enumerateKeysAndObjectsWithOptions:opts usingBlock:block]);</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;}</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;- (NSArray *)keysSortedByValueUsingComparator:(NSComparator)cmptr {</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSArray * a = [_dic keysSortedByValueUsingComparator:cmptr]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;}</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;- (NSArray *)keysSortedByValueWithOptions:(NSSortOptions)opts usingComparator:(NSComparator)cmptr {</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSArray * a = [_dic keysSortedByValueWithOptions:opts usingComparator:cmptr]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;}</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;- (NSSet *)keysOfEntriesPassingTest:(BOOL (^)(<span class="keywordtype">id</span> key, <span class="keywordtype">id</span> obj, BOOL *stop))predicate {</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSSet * a = [_dic keysOfEntriesPassingTest:predicate]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;}</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160; </div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;- (NSSet *)keysOfEntriesWithOptions:(NSEnumerationOptions)opts passingTest:(BOOL (^)(<span class="keywordtype">id</span> key, <span class="keywordtype">id</span> obj, BOOL *stop))predicate {</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSSet * a = [_dic keysOfEntriesWithOptions:opts passingTest:predicate]); <span class="keywordflow">return</span> a;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;}</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160; </div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="preprocessor">#pragma mark - mutable</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160; </div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;- (void)removeObjectForKey:(<span class="keywordtype">id</span>)aKey {</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic removeObjectForKey:aKey]);</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;}</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160; </div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;- (void)setObject:(<span class="keywordtype">id</span>)anObject forKey:(<span class="keywordtype">id</span> &lt;NSCopying&gt; )aKey {</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordflow">if</span> (anObject == nil || aKey == nil) {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        return ;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    }</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic setObject:anObject forKey:aKey]);</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;}</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;- (void)addEntriesFromDictionary:(NSDictionary *)otherDictionary {</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic addEntriesFromDictionary:otherDictionary]);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;}</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160; </div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;- (void)removeAllObjects {</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic removeAllObjects]);</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;}</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160; </div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;- (void)removeObjectsForKeys:(NSArray *)keyArray {</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic removeObjectsForKeys:keyArray]);</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;}</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;- (void)setDictionary:(NSDictionary *)otherDictionary {</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic setDictionary:otherDictionary]);</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;}</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160; </div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;- (void)setObject:(<span class="keywordtype">id</span>)obj forKeyedSubscript:(<span class="keywordtype">id</span> &lt;NSCopying&gt; )key {</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordflow">if</span> (obj == nil || key == nil) {</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        return ;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    }</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>([_dic setObject:obj forKeyedSubscript:key]);</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;}</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160; </div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="preprocessor">#pragma mark - protocol</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160; </div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;- (id)copyWithZone:(NSZone *)zone {</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="keywordflow">return</span> [<span class="keyword">self</span> mutableCopyWithZone:zone];</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;}</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160; </div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;- (id)mutableCopyWithZone:(NSZone *)zone {</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(<span class="keywordtype">id</span> copiedDictionary = [[<span class="keyword">self</span>.<span class="keyword">class</span> allocWithZone:zone] initWithDictionary:_dic]);</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keywordflow">return</span> copiedDictionary;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;}</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;- (NSUInteger)countByEnumeratingWithState:(NSFastEnumerationState *)state</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;                                  objects:(<span class="keywordtype">id</span> __unsafe_unretained[])stackbuf</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;                                    count:(NSUInteger)len {</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSUInteger count = [_dic countByEnumeratingWithState:state objects:stackbuf count:len]);</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <span class="keywordflow">return</span> count;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;}</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160; </div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;- (BOOL)isEqual:(<span class="keywordtype">id</span>)object {</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordflow">if</span> (<span class="keywordtype">object</span> == <span class="keyword">self</span>) <span class="keywordflow">return</span> YES;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    </div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <span class="keywordflow">if</span> ([<span class="keywordtype">object</span> isKindOfClass:<a class="code" href="interface_x_h_x_thread_safe_dictionary.html">XHXThreadSafeDictionary</a>.class]) {</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <a class="code" href="interface_x_h_x_thread_safe_dictionary.html">XHXThreadSafeDictionary</a> *other = object;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        BOOL isEqual;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        dispatch_semaphore_wait(_lock, DISPATCH_TIME_FOREVER);</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        dispatch_semaphore_wait(other-&gt;_lock, DISPATCH_TIME_FOREVER);</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        isEqual = [_dic isEqual:other-&gt;_dic];</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        dispatch_semaphore_signal(other-&gt;_lock);</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        dispatch_semaphore_signal(_lock);</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        <span class="keywordflow">return</span> isEqual;</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    }</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;}</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160; </div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;- (NSUInteger)hash {</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <a class="code" href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a>(NSUInteger hash = [_dic hash]);</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <span class="keywordflow">return</span> hash;</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;}</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="keyword">@end</span></div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160; </div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="keyword">@implementation </span><a class="code" href="category_n_s_mutable_dictionary_07_x_h_x_safe_08.html">NSMutableDictionary(XHXSafe)</a></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160; </div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;- (void)safe_setObject:(<span class="keywordtype">id</span>)anObject forKey:(<span class="keywordtype">id</span>&lt;NSCopying&gt;)aKey{</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    <span class="keywordflow">if</span> (anObject) {</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        [<span class="keyword">self</span> setObject:anObject forKey:aKey];</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    }</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;}</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160; </div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="keyword">@end</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="acategory_x_h_x_thread_safe_dictionary_07_08_html_ab51cad326f8cc54a6d19790ff716ae8b"><div class="ttname"><a href="category_x_h_x_thread_safe_dictionary_07_08.html#ab51cad326f8cc54a6d19790ff716ae8b">XHXThreadSafeDictionary()::_dic</a></div><div class="ttdeci">NSMutableDictionary * _dic</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_thread_safe_dictionary_8m_source.html#l00024">XHXThreadSafeDictionary.m:24</a></div></div>
<div class="ttc" id="a_x_h_x_thread_safe_dictionary_8m_html_afb8d9d5b560c7c17181409c6a43b6c21"><div class="ttname"><a href="_x_h_x_thread_safe_dictionary_8m.html#afb8d9d5b560c7c17181409c6a43b6c21">INIT</a></div><div class="ttdeci">#define INIT(...)</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_thread_safe_dictionary_8m_source.html#l00011">XHXThreadSafeDictionary.m:10</a></div></div>
<div class="ttc" id="a_x_h_x_thread_safe_dictionary_8h_html"><div class="ttname"><a href="_x_h_x_thread_safe_dictionary_8h.html">XHXThreadSafeDictionary.h</a></div></div>
<div class="ttc" id="a_x_h_x_thread_safe_dictionary_8m_html_a48ded6ef6e169fd2b9d98b42aab5aa69"><div class="ttname"><a href="_x_h_x_thread_safe_dictionary_8m.html#a48ded6ef6e169fd2b9d98b42aab5aa69">LOCK</a></div><div class="ttdeci">#define LOCK(...)</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_thread_safe_dictionary_8m_source.html#l00019">XHXThreadSafeDictionary.m:18</a></div></div>
<div class="ttc" id="ainterface_x_h_x_thread_safe_dictionary_html"><div class="ttname"><a href="interface_x_h_x_thread_safe_dictionary.html">XHXThreadSafeDictionary</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_thread_safe_dictionary_8h_source.html#l00011">XHXThreadSafeDictionary.h:11</a></div></div>
<div class="ttc" id="acategory_n_s_mutable_dictionary_07_x_h_x_safe_08_html"><div class="ttname"><a href="category_n_s_mutable_dictionary_07_x_h_x_safe_08.html">NSMutableDictionary(XHXSafe)</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_thread_safe_dictionary_8h_source.html#l00016">XHXThreadSafeDictionary.h:16</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_05f730b1f29a3e373a3d04cb5cb42ea7.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_2d533305e802e0a7e844b4ecd2e2bdb2.html">Classes</a></li><li class="navelem"><a class="el" href="dir_778ebd26e57377eb2e4b9acfa44c059f.html">Base</a></li><li class="navelem"><a class="el" href="dir_0598172aafe32c9cc3b37dc50f9bb9dd.html">Foundation</a></li><li class="navelem"><a class="el" href="_x_h_x_thread_safe_dictionary_8m.html">XHXThreadSafeDictionary.m</a></li>
    <li class="footer">制作者
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.18 </li>
  </ul>
</div>
</body>
</html>
